﻿module Code7_21

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let createBinaryTree() = 
    Node(1, Node(2, Node(4, Nil, Nil), 
                    Node(5, 
                            Node(6, Nil, Nil), 
                            Node(7, Nil, Nil))),
            Node(3, 
                    Nil,
                    Node(8, 
                            Nil, 
                            Node(9, Nil, Nil)))
        )

let mutable queue : BinaryTree list = []
let enqueue x = queue <- [x] @ queue
let dequeue() = 
    let result = Seq.last queue
    queue <-
        queue 
        |> Seq.take (queue.Length - 1)
        |> Seq.toList
    result
let queueEmpty() = queue.Length = 0

let mutable result = []
let visit v = result <- result @ [v]

let layerTree tree = 
    enqueue tree
    while not <| queueEmpty() do
        let tree = dequeue()
        match tree with
        | Nil -> ()
        | Node(v, left, right) -> 
            visit v
            enqueue left
            enqueue right

layerTree (createBinaryTree())
