﻿module Code7_25

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let getLeftPart inorder head = 
    inorder 
    |> Seq.takeWhile(fun n -> n <> head)
    |> Seq.toList

let getRightPart inorder head = 
    inorder
    |> Seq.skipWhile(fun n -> n <> head)
    |> Seq.skip 1
    |> Seq.toList

let getPreOrderLeftPart preorder inorderLeft = 
    let len = inorderLeft |> Seq.length
    preorder 
    |> Seq.skip 1
    |> Seq.take len
    |> Seq.toList

let getPreOrderRightPart preorder inorderLeft = 
    let len = inorderLeft |> Seq.length
    preorder
    |> Seq.skip 1
    |> Seq.skip len
    |> Seq.toList

let rec buildTree inorder preorder = 
    match preorder with
    | [] -> Nil
    | head::tail ->
        let inorderLeft = getLeftPart inorder head
        let inorderRight = getRightPart inorder head
        let preorderLeft = getPreOrderLeftPart preorder inorderLeft
        let preorderRight = getPreOrderRightPart preorder inorderLeft
        Node(head, 
             buildTree inorderLeft preorderLeft,
             buildTree inorderRight preorderRight)

buildTree [1; 2; 3; 4; 5; 6; 7; 9] [6; 4; 2; 1; 3; 5; 7; 9]
