﻿module Code7_31

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let createBinaryTree() = 
    Node(20, Node(8, Node(5, Nil, Nil), 
                             
                     Node(12,  
                            Node(11, Nil, Nil), 
                            Node(15, Nil, Nil))),
            Node(30, 
                    Node(21, Nil, Nil),
                    Node(32, Nil, Nil))
        )

let tree = createBinaryTree()

let rec findLCAInBST (n0, n1) root = 
    match root with 
    | Nil -> None
    | Node(v, left, right) ->
        if v >= n0 && v <= n1 then 
            Some v
        elif v > n0 && v > n1 then 
            findLCAInBST (n0, n1) left
        else
            findLCAInBST (n0, n1) right

tree |> findLCAInBST (3, 15)
