﻿module Code7_33

type NodeType = int

type BinaryTree = 
    | Nil 
    | Node of NodeType * BinaryTree * BinaryTree

let createBinaryTree() = 
    Node(1, Node(2, Node(4, Nil, Nil), 
                        Node(5, 
                            Node(6, Nil, Nil), 
                            Node(7, Nil, Nil))),
            Node(3, 
                    Nil,
                    Node(8, 
                            Nil, 
                            Node(9, Nil, Nil)))
        )

let mutable result = []
let add x = 
    result <- result @ [x]

let rec visitLeaf root = 
    match root with
    | Nil -> ()
    | Node(v, Nil, Nil) -> add v
    | Node(v, left, right) -> 
        visitLeaf left
        visitLeaf right

let rec visitLeftBoundary root = 
    match root with
    | Nil -> ()
    | Node(v, Nil, Nil) -> ()    
    | Node(v, Nil, right) ->
        add v
        visitLeftBoundary right
    | Node(v, left, _) -> 
        add v
        visitLeftBoundary left

let rec visitRightBoundary root =
    match root with
    | Nil -> ()
    | Node(v, Nil, Nil) -> ()
    | Node(v, left, Nil) ->  
        visitRightBoundary left
        add v
    | Node(v, _, right) ->
        visitRightBoundary right
        add v

let getBoundary root = 
    match root with
    | Nil -> ()
    | Node(v, left, right) ->
        add v
        visitLeftBoundary left
        visitLeaf left
        visitLeaf right
        visitRightBoundary right

let tree = createBinaryTree()

getBoundary tree
