﻿module Code7_37

open System

let (| AllEmpty | Str0NotEmpty | Str1NotEmpty | Both |) (str0, str1) = 
    let b0 = String.IsNullOrEmpty(str0)
    let b1 = String.IsNullOrEmpty(str1)
    match b0, b1 with
    | true, true -> AllEmpty
    | false, true -> Str0NotEmpty
    | true, false -> Str1NotEmpty
    | false, false -> Both    

let mutable result = []
let add x = 
    result <- result @ [x]

let interLeaving str0 str1 = 
    let rec interLeavingStrs str0 str1 current = 
        match str0, str1 with
        | AllEmpty _ -> ()
        | Str1NotEmpty -> add (current+str1)
        | Str0NotEmpty -> add (current+str0)
        | Both -> 
            interLeavingStrs (str0.Substring(1)) str1 (current + string str0.[0])
            interLeavingStrs str0 (str1.Substring(1)) (current + string str1.[0])

    interLeavingStrs str0 str1 ""

interLeaving "ab" "cd"
